import React, { PureComponent } from 'react';
// eslint-disable-next-line
import { Form, Input, Row, Col, Tabs, Icon, Collapse } from 'antd';
import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '../../../ibizsys/form-detail';
import './${srffilepath2(ctrl.codeName)}.less';
const { TabPane } = Tabs;
const { Panel } = Collapse;

/**
 * 表单属性
 *
 * @export
 * @interface ${srfclassname(ctrl.codeName)}FormData
 */
export interface ${srfclassname(ctrl.codeName)}FormData {
<#list ctrl.getPSDEFormItems() as item>
<#if item.getName()?index_of('srf') != 0>
    /**
     * <#if item.getCaption()??>${item.getCaption()}<#else>${item.getName()}</#if>
     *
     * @type {*}
     * @memberof ${srfclassname(ctrl.codeName)}FormData
     */
    ${item.getName()}?: any;
</#if>
</#list>
}

/**
 * 输入属性
 *
 * @export
 * @interface ${srfclassname(ctrl.codeName)}Props
 */
export interface ${srfclassname(ctrl.codeName)}Props {
    /**
     * 表单数据对象
     *
     * @type {${srfclassname(ctrl.codeName)}FormData}
     * @memberof ${srfclassname(ctrl.codeName)}Props
     */
    data?: ${srfclassname(ctrl.codeName)}FormData;
    /**
     * 表单分页切换
     *
     * @memberof ${srfclassname(ctrl.codeName)}Props
     */
    tabChange?: (key: string) => void;
}

/**
 * ${srfclassname(ctrl.codeName)}
 *
 * @export
 * @class ${srfclassname(ctrl.codeName)}
 * @extends {PureComponent}
 */
export default class ${srfclassname(ctrl.codeName)} extends PureComponent<${srfclassname(ctrl.codeName)}Props> {
    /**
     * 表单数据
     *
     * @type {*}
     * @memberof ${srfclassname(ctrl.codeName)}
     */
    public data: ${srfclassname(ctrl.codeName)}FormData = {};
    
    /**
     * 在组件接收到一个新的 prop (或更新后)时被调用
     *
     * @memberof IBizViewController
     */
    public componentWillReceiveProps(nextProps: Readonly<${srfclassname(ctrl.codeName)}Props>, nextContext: any) {
        if (this.data && nextProps.data && !Object.is(JSON.stringify(this.data), JSON.stringify(nextProps.data))) {
            Object.assign(this.data, nextProps.data);
        }
    }

    /**
     * 在组件从 DOM 中移除的时候立刻被调用
     *
     * @memberof IBizViewController
     */
    public componentWillUnmount() {

    }

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof ${srfclassname(ctrl.codeName)}
     */
    public rules: any = {
        <#list ctrl.getAllPSDEFormDetails() as formdetail>
        <#if formdetail.getDetailType?? && formdetail.getDetailType() == 'FORMITEM'>
        ${formdetail.getName()}: [
            { type: '<#assign datatype=srfjavatype(formdetail.getStdDataType())><#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>number<#else>string</#if>', message: '${formdetail.getCaption()} 值必须为<#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>数值<#else>字符串</#if>类型', trigger: 'change' },
            { required: <#if formdetail.isAllowEmpty()>false<#else>true</#if>, type: '<#assign datatype=srfjavatype(formdetail.getStdDataType())><#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>number<#else>string</#if>', message: '${formdetail.getCaption()} 值不能为空', trigger: 'change' },
            { required: <#if formdetail.isAllowEmpty()>false<#else>true</#if>, type: '<#assign datatype=srfjavatype(formdetail.getStdDataType())><#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>number<#else>string</#if>', message: '${formdetail.getCaption()} 值不能为空', trigger: 'blur' },
        ],
        </#if>
        </#list>
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof ${srfclassname(ctrl.codeName)}
     */
    public detailsModel: any = {
        <#list ctrl.getAllPSDEFormDetails() as formdetail>
        ${formdetail.name}: ${P.getPartCode(formdetail, 'DETAIL_MODEL').code},
        </#list>
        <#if !ctrl.isNoTabHeader()>
        ${ctrl.name}: new FormTabPanelModel({ caption: '${ctrl.name}', detailType: 'TABPANEL', name: '${ctrl.name}', visible: true, isShowCaption: true, form: this, tabPages: [<#list ctrl.getPSDEFormPages() as formmenber><#if formmenber_index gt 0>, </#if>{ name: '${formmenber.name}', index: ${formmenber_index}, visible: <#if formmenber.getPSDEFDGroupLogic('PANELVISIBLE')??>false<#else>true</#if> }</#list>] }),
        </#if>
    };

    /**
     * 表单逻辑
     *
     * @private
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof ${srfclassname(ctrl.codeName)}
     */
    private formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        <#if P.getPartCode(item,'FORM_LOGIC').code?length gt 0>
        ${P.getPartCode(item,'FORM_LOGIC').code}
        </#if>
        <#if ctrl.getPSDEFormItems()??>
        <#list ctrl.getPSDEFormItems() as formitem>
        <#if formitem.getPSDEFormItemUpdate()??>
        <#assign itemUpdate=formitem.getPSDEFormItemUpdate()/>

        if(Object.is(name, '${formitem.name}')){
            const details: string[] = [<#list itemUpdate.getPSDEFIUpdateDetails() as detail><#if detail_index gt 0>, </#if>'${detail.getPSDEFormDetailName()?lower_case}'</#list>];
            this.updateFormItems('${itemUpdate.codeName}', this.data, details, ${itemUpdate.isShowBusyIndicator()?c});
        }
        </#if>
        </#list>
        </#if>
    }

    <#list ctrl.getAllPSDEFormDetails() as formdetail>
    <#if formdetail.getDetailType?? && formdetail.getDetailType() == 'BUTTON'>
    <#if formdetail.getActionType?? && formdetail.getActionType()??>
    <#if formdetail.getActionType() == 'UIACTION'>

	/**
	 * 表单 ${formdetail.getCaption()} 事件
	 *
	 * @memberof @memberof ${srfclassname('${ctrl.codeName}')}
	 */
    public ${formdetail.getName()}_click($event: any): void {
        alert('需自定义实现');
    }
    </#if>
    <#if formdetail.getActionType() == 'FIUPDATE'>

	/**
	 * 表单 ${formdetail.getCaption()} 事件
	 *
	 * @memberof @memberof ${srfclassname('${ctrl.codeName}')}
	 */
    public ${formdetail.getName()}_click($event: any): void {
        alert('需自定义实现');
    }
    </#if>
    </#if>
    </#if>
    </#list>

    /**
     * 表单分页切换
     *
     * @param {string} key 分页标识
     * @memberof ${srfclassname(ctrl.codeName)}
     */
    public tabChange(key: string): void {
        if (this.props.tabChange) {
            this.props.tabChange(key);
        }
    }

    /**
     * 绘制内容
     *
     * @returns
     * @memberof ${srfclassname(ctrl.codeName)}
     */
    public render(): any {
        return <>
            ${P.getPartCode(item,'FORM').code}
        </>;
    }

    /**
     * 变更监测
     *
     * @protected
     * @memberof Main
     */
    protected tick(): void {
        this.setState({
            date: new Date()
        });
    }

}